package com.engine.organization.util;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import org.apache.commons.collections.CollectionUtils;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author:dxfeng
 * @createTime: 2022/06/23
 * @version: 1.0
 */
public class PageInfoSortUtil {

    /**
     * 获取排序SQL规则
     *
     * @param sortParams
     * @return
     */
    public static String getSortSql(String sortParams) {
        JSONArray jsonArray  = JSONObject.parseArray(sortParams);
        if (CollectionUtils.isNotEmpty(jsonArray)) {
            JSONObject jsonObject = (JSONObject) jsonArray.get(0);
            String orderKey = upperCharToUnderLine(jsonObject.getString("orderkey"));
            String sortOrder = jsonObject.getString("sortOrder").replace("end", "");
            return "t." + orderKey + " " + sortOrder;
        }
        return " show_order ";
    }

    /**
     * 驼峰转下划线
     *
     * @param param
     * @return
     */
    private static String upperCharToUnderLine(String param) {
        Pattern p = Pattern.compile("[A-Z]");
        if (param == null || param.equals("")) {
            return "";
        }
        StringBuilder builder = new StringBuilder(param);
        Matcher mc = p.matcher(param);
        int i = 0;
        while (mc.find()) {
            builder.replace(mc.start() + i, mc.end() + i, "_" + mc.group().toLowerCase());
            i++;
        }
        if ('_' == builder.charAt(0)) {
            builder.deleteCharAt(0);
        }
        return builder.toString();
    }
}
